from PIL import ImageGrab, Image
from numpy import array
import obspython as obs
from time import sleep
from threading import Thread

##########################################################################
# Main variables
running = True

is_hidden = False

##########################################################################
# OBS Functions

def script_description():
    return "Automatically hides the Rust map when you die"

def script_properties():
    props = obs.obs_properties_create()
    isEnabled_prop = obs.obs_properties_add_bool(props, "isEnabled", "Enable the script"); obs.obs_property_set_long_description(isEnabled_prop, "If disabled, it will stop checking if you are death")
    rustScene_prop = obs.obs_properties_add_text(props, "rustScene", "Rust scene", obs.OBS_TEXT_DEFAULT); obs.obs_property_set_long_description(rustScene_prop, "The scene that is currently showing your game")
    hideScene_prop = obs.obs_properties_add_text(props, "scene", "Hide scene", obs.OBS_TEXT_DEFAULT); obs.obs_property_set_long_description(hideScene_prop, "The scene that will show up when you die")
    cooldown_prop = obs.obs_properties_add_int(props,"cooldown","Check period (ms)",50,150,10); obs.obs_property_set_long_description(cooldown_prop, "The scene that will show up when you die")
    return props


def script_load(settings):
    global replace_scene
    print("Loading the script...")

def script_update(settings):
    global is_enabled, rust_scene, replace_scene, cooldown
    is_enabled = obs.obs_data_get_bool(settings, "isEnabled")
    rust_scene = obs.obs_data_get_string(settings, "rustScene")
    replace_scene = obs.obs_data_get_string(settings, "scene")
    cooldown = obs.obs_data_get_int(settings, "cooldown")
    print("Update", replace_scene)

def script_unload():
    global running, t
    print("Unloading...")
    print("Stopping checker thread...")
    running = False
    t.join()
    print("The script was successfully unloaded. Cya")

##########################################################################
def hide():
    global is_hidden, replace_scene
    #Wanna be performance friendly :D
    if is_hidden == True:
        return
    is_hidden = True
    for scene in obs.obs_frontend_get_scenes():
        if obs.obs_source_get_name(scene) == replace_scene:
            obs.obs_frontend_set_current_scene(scene)

def show():
    global rust_scene, is_hidden

    if is_hidden == False:
        return
    is_hidden = False
    for scene in obs.obs_frontend_get_scenes():
        if obs.obs_source_get_name(scene) == rust_scene:
            obs.obs_frontend_set_current_scene(scene)
        
def checker():
    global running, enabled, cooldown, is_enabled
    while running:
        print(is_enabled)
        if is_enabled:
            image = ImageGrab.grab(bbox=(0, 0, 453, 142))
            if (array(image) == array(death_screen)).all():
                hide()
            else:
                show()
            sleep(cooldown/1000)
        else:
            sleep(1)

death_screen = Image.open("image_new_new_new.png")

#Makes it deamon just in case 
t = Thread(target=checker, daemon=True)
t.start()
